Subject: The Paradigms of Programming
From: Robert Floyd <[email-masked]>
To: Alan Turing <[email-masked]>
Date: Mon, 04 Dec 1978 12:00:00 -0500

Today I want to talk about the paradigms of programming, how they affect 
our success as designers of computer programs, how they should be taught, 
and how they should be embodied in our programming languages. 
A familiar example of a paradigm of programming is the technique of 
structured programming, which appears to be the dominant paradigm in most 
current treatments of programming methodology. Structured programming, as 
formulated by Dijkstra, Wirth, and Parnas, among others, consists of two 
phases.